; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; !!! For checking with aligned string, define (uncomment) next macro:
; CHECK_AS_ALIGNED = 1


.nolist
include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc 
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000	; 1000000 would be a typical value

a16 MACRO
	align 16
	REPEAT 16
		INT 3
	ENDM
ENDM

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  push offset Src
  call algo
  .if eax!=sizeof Src-1
	print str$(eax), " - ERROR", 13, 10
  .endif
  popad
ENDM

.data
align 16
ifndef CHECK_AS_ALIGNED
db 9 dup (0)
endif
Src	db 1 dup("This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."),0
db 5 dup (123)


.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	CodeSize MbStrLen1
	CodeSize MbStrLen2
	CodeSize MbStrLen3
	CodeSize MbStrLen4a
	CodeSize MbStrLen4b
	CodeSize MbStrLen5
	CodeSize AxStrLenMMX
	CodeSize AxStrLenSSE1
	CodeSize StrLen
	print chr$(13, 10)
	rct=5
	REPEAT rct
	push eax
;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push offset Src
;		call szLen
;	counter_end
;	print str$(eax), 9, "cycles for szLen", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen1
	counter_end
	print str$(eax), 9, "cycles for MbStrLen1", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen2
	counter_end
	print str$(eax), 9, "cycles for MbStrLen2", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen3
	counter_end
	print str$(eax), 9, "cycles for MbStrLen3", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen4a
	counter_end
	print str$(eax), 9, "cycles for MbStrLen4a", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen4b
	counter_end
	print str$(eax), 9, "cycles for MbStrLen4b", 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbStrLen5
	counter_end
	print str$(eax), 9, "cycles for MbStrLen5", 13, 10, 10
	
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call AxStrLenMMX
	counter_end
	print str$(eax), 9, "cycles for AxStrLenMMX", 13, 10, 10
	
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call AxStrLenSSE1
	counter_end
	print str$(eax), 9, "cycles for AxStrLenSSE1", 13, 10, 10
	
	
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call StrLen
	counter_end
	print str$(eax), 9, "cycles for StrLen", 13, 10, 10
	
	ENDM
	
	add esp, rct*4
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

a16
MbStrLen1_s:
MbStrLen1 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
;int 3
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	; nop	; one nop means align 16 for innermost loop but has no effect on Celeron
	push edx	; edx preserved because Masm32 szLen preserves it
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	pop edx
	pop ecx
	ret 4
MbStrLen1 endp
MbStrLen1_endp:
a16
MbStrLen2_s:
MbStrLen2 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 8+16
	mov eax, [esp+4]	; get the src pointer
	sub esp, xtrabytes
	mov [esp], ecx	; Mb ABI: ecx is safe ;-)
	mov [esp+4], edx	; edx preserved because Masm32 szLen preserves it
	movups [esp+8], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+4+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	mov ecx, [esp]	; Mb ABI: ecx is safe ;-)
	mov edx, [esp+4]	; edx preserved because Masm32 szLen preserves it
	movups xmm0, [esp+8]
	add esp, xtrabytes
	ret 4
MbStrLen2 endp
MbStrLen2_endp:
a16
MbStrLen3_s:
MbStrLen3 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	movdqu [esp], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	movups xmm0, [esp]
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen3 endp
MbStrLen3_endp:
a16
MbStrLen4a_s:
MbStrLen4a proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	if 1
	movlps qword ptr [esp], xmm0
	movhps qword ptr [esp+8], xmm0
	else
	movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
		push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 1
	movlps xmm0, qword ptr [esp]
	movhps xmm0, qword ptr [esp+8]
	else
	movups xmm0, [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4a endp
MbStrLen4a_endp:
a16
MbStrLen4b_s:
MbStrLen4b proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	;int 3
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	if 0
	movlps qword ptr [esp], xmm0
	movhps qword ptr [esp+8], xmm0
	else
	movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
		push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 0
	movlps xmm0, qword ptr [esp]
	movhps xmm0, qword ptr [esp+8]
	else
	movups xmm0, [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4b endp
MbStrLen4b_endp:
a16
MbStrLen5_s:
MbStrLen5 proc uses ecx edx src:DWORD	; *** SSE2-safe version of 3.8.10, 59 bytes ***
LOCAL xmmbuffer[16]:BYTE
	if 1
	movlps qword ptr xmmbuffer, xmm0
	movhps qword ptr xmmbuffer+8, xmm0
	else
	movdqu [esp], xmm0
	endif
	mov eax, src	; get the src pointer
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
	push ecx
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 1
	movlps xmm0, qword ptr xmmbuffer
	movhps xmm0, qword ptr xmmbuffer+8
	else
	movups xmm0, [esp]
	endif
	ret
MbStrLen5 endp
MbStrLen5_endp:





OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
db 12 dup (0CCh)
AxStrLenMMX_s:
AxStrLenMMX	proc STDCALL lpszStr:DWORD	; SSE safe, because MMX :), ECX safe :), trashed last FPU reg :)
	;int 3
	mov edx,[esp+4]
	@@:
	pxor mm7,mm7		; if carry out this from loop, then loop is slower
	pcmpeqb mm7,[edx]	; if you check this, don't forgot change count of dup to 9 (not 12)
	add edx,8
	pmovmskb eax,mm7
	test eax,eax
	jz @B
	bsf eax,eax
	sub edx,[esp+4]
	lea eax,[eax+edx-8]
	ret 4
AxStrLenMMX	endp
AxStrLenMMX_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef



OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
db 14 dup (0)
AxStrLenSSE1_s:
AxStrLenSSE1	proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	;int 3					; the same iteresting: unaligned: 61 clock, aligned: 63.
	mov edx,[esp+4]
	mov eax,[esp+4]
	add esp,-10h
	movups [esp],xmm7
	and eax,0fh
	jz @F
	movups xmm7,[edx]
	pcmpeqb xmm7,@anZero
	add edx,0fh
	pmovmskb eax,xmm7
	and edx,-10h
	bsf eax,eax
	jnz @ret
	@@:
	pxor xmm7,xmm7
	align 16
	@@:
	pcmpeqb xmm7,[edx]
	add edx,16
	pmovmskb eax,xmm7
	test eax,eax
	jz @B	
	
	bsf eax,eax
	sub edx,[esp+4+16]
	lea eax,[eax+edx-10h]
	
	@ret:
	movups xmm7,[esp]
	add esp,10h
	ret 4	
	
	.data?
	align 16
	@anZero label OWORD
				dq ?,?
	.code
	
AxStrLenSSE1	endp
AxStrLenSSE1_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4
StrLen_s:
StrLen proc item:DWORD

    mov     eax, [esp+4]            ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
    push    ebp
    push    edi
    mov     ebp, 80808080h

  @@:     
  REPEAT 3
    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jnz     nxt
  ENDM

    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; 4 increment DWORD pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jz      @B                      ; no zero bytes, continue loop

  nxt:
    test    ecx, 00008080h          ; test first two bytes
    jnz     @F
    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2
  @@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length
    pop     edi
    pop     ebp

    ret     4

StrLen endp
StrLen_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 



ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
